﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace KollisionerMedRektanglar
{

    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //Vår grafik
        Texture2D ship;
        Texture2D meteor;
        Texture2D red;
        Texture2D hit;

        //Positioner
        double playerX, playerY, meteorX = 300, meteorY = 200;

        //Överlappande rektangel
        Rectangle kollision;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 640;
            graphics.PreferredBackBufferHeight = 480;
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            ship = Content.Load<Texture2D>("ship");
            meteor = Content.Load<Texture2D>("meteor");
            red = Content.Load<Texture2D>("red");
            hit = Content.Load<Texture2D>("hit");
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();

            MouseState m = Mouse.GetState();
            playerX = m.X;
            playerY = m.Y;

            Rectangle playerBox = new Rectangle((int)playerX, (int)playerY, 48, 60);
            Rectangle meteorBox = new Rectangle((int)meteorX, (int)meteorY, 110, 110);

            //Överlappar vi?
            kollision = Intersection(playerBox, meteorBox);

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            spriteBatch.Draw(meteor, new Rectangle((int)meteorX, (int)meteorY, 110, 110), Color.White);
            spriteBatch.Draw(ship, new Rectangle((int)playerX, (int)playerY, 48, 60), Color.White);
            //Har vi en röd rektangel?
            if (kollision.Width > 0)
            {
                spriteBatch.Draw(red, kollision, new Rectangle(0, 0, kollision.Width, kollision.Height), Color.White);
                spriteBatch.Draw(hit, new Rectangle(150, 10, 150, 50), Color.White);
            }

            spriteBatch.End();

            base.Draw(gameTime);
        }

        public static Rectangle Intersection(Rectangle r1, Rectangle r2)
        {
            int x1 = Math.Max(r1.Left, r2.Left);
            int y1 = Math.Max(r1.Top, r2.Top);
            int x2 = Math.Min(r1.Right, r2.Right);
            int y2 = Math.Min(r1.Bottom, r2.Bottom);

            if ((x2 >= x1) && (y2 >= y1))
            {
                return new Rectangle(x1, y1, x2 - x1, y2 - y1);
            }
            return Rectangle.Empty;
        }
    }
}
